'use strict';

var _powerAssertRecorder = function () { function PowerAssertRecorder() { this.captured = []; } PowerAssertRecorder.prototype._capt = function _capt(value, espath) { this.captured.push({ value: value, espath: espath }); return value; }; PowerAssertRecorder.prototype._expr = function _expr(value, source) { return { powerAssertContext: { value: value, events: this.captured }, source: source }; }; return PowerAssertRecorder; }(); /* eslint-env mocha */

var _fs = require('fs');

var _fs2 = _interopRequireDefault(_fs);

var _babelCore = require('babel-core');

var _path = require('path');

var _path2 = _interopRequireDefault(_path);

var _powerAssert = require('power-assert');

var _powerAssert2 = _interopRequireDefault(_powerAssert);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var exampleFile = _fs2.default.readFileSync(_path2.default.join(__dirname, 'data', 'Example.js')).toString();

var exampleTranspiledFileName = _path2.default.join(__dirname, 'data', 'ExampleTranspiled.js');

var pluginPath = _path2.default.join(__dirname, '..', '..', 'dist', 'index.js');

var babelConfig = {
    plugins: ['syntax-flow', 'syntax-decorators', [pluginPath, {
        metaDriver: 'symbol',
        driverImport: 'reactive-di/inject'
    }]]
};

describe('transformTest', function () {
    it('test successful for Example', function () {
        var _rec = new _powerAssertRecorder();

        var _transform = (0, _babelCore.transform)(exampleFile, babelConfig);

        var code = _transform.code;
        // console.log(code)
        // fs.writeFileSync(exampleTranspiledFileName, code)

        var exampleTranspiledFile = _fs2.default.readFileSync(exampleTranspiledFileName).toString();
        (0, _powerAssert2.default)(_rec._expr(_rec._capt(_rec._capt(code, 'arguments/0/left') === _rec._capt(exampleTranspiledFile, 'arguments/0/right'), 'arguments/0'), {
            content: 'assert(code === exampleTranspiledFile)',
            filepath: 'src/__tests__/transformTest.js',
            line: 33
        }));
    });
});
//# sourceMappingURL=transformTest.js.map