'use strict';

exports.__esModule = true;
exports.default = createCreateCreateGenericTypeMetadata;

var _babelGenerator = require('babel-generator');

var _babelGenerator2 = _interopRequireDefault(_babelGenerator);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var TAG = '[babel-plugin-transform-metadata]';

function createCreateCreateGenericTypeMetadata(t, externalTypeNames, internalTypes, depsId, externalClassNames) {
    return function createCreateGenericTypeMetadata(createObjectTypeMetadata) {
        return function createGenericTypeMetadata(annotation) {
            var id = annotation.id;
            if (id.name === depsId) {
                return createObjectTypeMetadata(annotation.typeParameters.params[0]);
            }
            if (!externalClassNames.has(id.name)) {
                // console.log(externalClassNames)
                return t.stringLiteral(id.name);
                // return createObjectTypeMetadata(internalType)
                // throw new Error(`Unknown type detected: ${generate(annotation).code}`)
            }

            if (annotation.typeParameters) {
                var genericCode = (0, _babelGenerator2.default)(annotation).code;
                var plainCode = (0, _babelGenerator2.default)(annotation.id).code;
                /* eslint-disable no-console */
                console.warn(TAG + ' Generic type is not supported: ' + genericCode + ' Just use: ' + plainCode);
            }
            var internalType = internalTypes.get(id.name);
            if (internalType) {
                return createObjectTypeMetadata(internalType);
            }
            var imported = externalTypeNames.get(id.name);
            if (imported) {
                id = t.stringLiteral(imported);
            }
            return id;
        };
    };
}
//# sourceMappingURL=createCreateCreateGenericTypeMetadata.js.map