'use strict';

exports.__esModule = true;
exports.default = createHasComment;
function createHasComment(argComment) {
    return function hasComment(type) {
        var isTrailing /*: boolean*/ = arguments.length <= 1 || arguments[1] === undefined ? false : arguments[1];

        var comments = isTrailing ? type.trailingComments : type.leadingComments;
        if (comments && comments.length > 0) {
            var comment = (comments[0].value || '').trim();
            if (comment === argComment) {
                return true;
            }
        }

        return false;
    };
}
//# sourceMappingURL=createHasComment.js.map