'use strict';

exports.__esModule = true;
exports.default = createTypeForAnnotation;
function createTypeForAnnotation(t, externalTypeNames, createCreateObjectTypeMetadata, createCreateGenericTypeMetadata) {
    var createGenericTypeMetadata = void 0;
    var createObjectTypeMetadata = void 0;

    function typeForAnnotation(annotation) {
        if (!annotation) {
            return null;
        }
        switch (annotation.type) {
            case 'StringTypeAnnotation':
                return t.identifier('String');
            case 'NumberTypeAnnotation':
                return t.identifier('Number');
            case 'BooleanTypeAnnotation':
                return t.identifier('Boolean');
            case 'VoidTypeAnnotation':
                return t.unaryExpression('void', t.numericLiteral(0));
            case 'GenericTypeAnnotation':
                return createGenericTypeMetadata(annotation);
            case 'ObjectTypeAnnotation':
                return createObjectTypeMetadata(annotation);
            case 'FunctionTypeAnnotation':
                return t.identifier('Function');
            default:
                return null;
        }
    }
    createObjectTypeMetadata = createCreateObjectTypeMetadata(typeForAnnotation);
    createGenericTypeMetadata = createCreateGenericTypeMetadata(createObjectTypeMetadata);
    return typeForAnnotation;
}
//# sourceMappingURL=createTypeForAnnotation.js.map