'use strict';

exports.__esModule = true;
exports.default = babelPluginTransformReactiveDi;

var _getTypesInfo = require('./visitors/getTypesInfo');

var _getTypesInfo2 = _interopRequireDefault(_getTypesInfo);

var _addReflections = require('./visitors/addReflections');

var _addReflections2 = _interopRequireDefault(_addReflections);

var _createTypeForAnnotation = require('./factories/createTypeForAnnotation');

var _createTypeForAnnotation2 = _interopRequireDefault(_createTypeForAnnotation);

var _createCreateCreateGenericTypeMetadata = require('./factories/createCreateCreateGenericTypeMetadata');

var _createCreateCreateGenericTypeMetadata2 = _interopRequireDefault(_createCreateCreateGenericTypeMetadata);

var _createCreateCreateObjectTypeMetadata = require('./factories/createCreateCreateObjectTypeMetadata');

var _createCreateCreateObjectTypeMetadata2 = _interopRequireDefault(_createCreateCreateObjectTypeMetadata);

var _createTypeForAnnotations = require('./factories/createTypeForAnnotations');

var _createTypeForAnnotations2 = _interopRequireDefault(_createTypeForAnnotations);

var _createHasComment = require('./factories/createHasComment');

var _createHasComment2 = _interopRequireDefault(_createHasComment);

var _createGetUniqueTypeName = require('./factories/createGetUniqueTypeName');

var _createGetUniqueTypeName2 = _interopRequireDefault(_createGetUniqueTypeName);

var _createParentPathInsertAfter = require('./modifiers/createParentPathInsertAfter');

var _createParentPathInsertAfter2 = _interopRequireDefault(_createParentPathInsertAfter);

var _createReplaceMagicTypeCasts = require('./modifiers/createReplaceMagicTypeCasts');

var _createReplaceMagicTypeCasts2 = _interopRequireDefault(_createReplaceMagicTypeCasts);

var _createInjectorDeclaration = require('./metaCreators/createInjectorDeclaration');

var _createInjectorDeclaration2 = _interopRequireDefault(_createInjectorDeclaration);

var _createInjectParamTypes = require('./metaCreators/createInjectParamTypes');

var _createInjectParamTypes2 = _interopRequireDefault(_createInjectParamTypes);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function babelPluginTransformReactiveDi(_ref) {
    var t = _ref.types;

    return {
        visitor: {
            Program: function Program(path, _ref2) {
                var file = _ref2.file;
                var opts = _ref2.opts;

                var getUniqueTypeName = (0, _createGetUniqueTypeName2.default)(opts.typeNameStrategy || 'fullPath');
                var state = {
                    getUniqueTypeName: getUniqueTypeName,
                    driverImport: opts.driverImport,
                    ambiantTypeCastImport: opts.ambiantTypeCastImport || 'babel-plugin-transform-metadata/_',
                    ambiantDepsImport: opts.ambiantDepsImport || 'babel-plugin-transform-metadata/Deps',

                    lastImportPath: null,
                    depsId: null,
                    injectId: null,
                    ambiantTypeCast: null,
                    externalClassNames: new Map(),
                    internalTypes: new Map(),
                    externalTypeNames: new Map(),
                    exportNames: new Map()
                };
                state.externalTypeNames.delete(state.depsId);
                path.traverse(_getTypesInfo2.default, state);

                var replaceMagicTypeCasts = (0, _createReplaceMagicTypeCasts2.default)(t, state.externalTypeNames);
                var hasComment = (0, _createHasComment2.default)(opts.argComment || '@args');
                var createCreateObjectTypeMetadata = (0, _createCreateCreateObjectTypeMetadata2.default)(t, hasComment, state.depsId);
                var createCreateGenericTypeMetadata = (0, _createCreateCreateGenericTypeMetadata2.default)(t, state.externalTypeNames, state.internalTypes, state.depsId, state.externalClassNames);
                var typeForAnnotation = (0, _createTypeForAnnotation2.default)(t, state.externalTypeNames, createCreateObjectTypeMetadata, createCreateGenericTypeMetadata);
                var typeForAnnotations = (0, _createTypeForAnnotations2.default)(hasComment, typeForAnnotation, state.depsId);

                var injectId = state.injectId || file.scope.generateUidIdentifier('inject');

                var injectorDeclaration = null;
                if (opts.metaDriver !== 'import' || !state.injectId) {
                    injectorDeclaration = (0, _createInjectorDeclaration2.default)(t, opts.driverImport, opts.metaDriver || 'symbol', injectId, 'design:paramtypes');
                }

                var defineParamTypes = (0, _createInjectParamTypes2.default)(t, injectId, typeForAnnotations);

                var parentPathInsertAfter = (0, _createParentPathInsertAfter2.default)(defineParamTypes);

                var reflectionState = {
                    magicTypeCasts: [],
                    parentPaths: [],
                    exportNames: state.exportNames,
                    magicTypeCastExpression: state.ambiantTypeCast ? state.ambiantTypeCast.node.specifiers[0].local.name : ''
                };

                path.traverse(_addReflections2.default, reflectionState);

                reflectionState.magicTypeCasts.forEach(replaceMagicTypeCasts);
                reflectionState.parentPaths.forEach(parentPathInsertAfter);
                if (state.ambiantTypeCast) {
                    state.ambiantTypeCast.remove();
                }
                if (injectorDeclaration) {
                    if (state.lastImportPath) {
                        state.lastImportPath.insertAfter(injectorDeclaration);
                    } else {
                        path.node.body.unshift(injectorDeclaration);
                    }
                }
            }
        }
    };
}
//# sourceMappingURL=index.js.map