'use strict';

exports.__esModule = true;
var addReflections = {
    TypeCastExpression: function TypeCastExpression(path, _ref) {
        var magicTypeCasts = _ref.magicTypeCasts;
        var magicTypeCastExpression = _ref.magicTypeCastExpression;

        if (path.node.expression.name === magicTypeCastExpression) {
            magicTypeCasts.push(path);
        }
    },
    'ClassDeclaration|FunctionDeclaration': function ClassDeclarationFunctionDeclaration(path, _ref2) {
        var parentPaths = _ref2.parentPaths;
        var exportNames = _ref2.exportNames;

        var node = path.node;
        var parent = path.parent;
        var ref = node.id;
        if (!exportNames.has(ref.name)) {
            return;
        }
        var isInsertAfter = parent.type === 'ExportNamedDeclaration' || parent.type === 'ExportDefaultDeclaration';

        var params = void 0;
        if (node.type === 'ClassDeclaration') {
            var constr = node.body.body.find(function (bodyNode) {
                return bodyNode.type === 'ClassMethod' && bodyNode.kind === 'constructor';
            });
            if (constr) {
                params = constr.params;
            }
        } else {
            params = node.params;
            // console.log(params)
        }

        if (params) {
            parentPaths.push([isInsertAfter ? path.parentPath : path, params, ref]);
        }
    }
};

exports.default = addReflections;
//# sourceMappingURL=addReflections.js.map